// EtcTools.h	JJWorks e틤ʃTu[`Q
//
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EtcTools.h"
#include "Resource.h"

#include <math.h>

/*-------------------------------------------------------------------------*/
// Hex4Byte2Int	SoCĝPUi𐔒lɕϊ
/*-------------------------------------------------------------------------*/
int
Hex4Byte2Int(CString inHexStr)
{
	ASSERT(inHexStr.GetLength() == 4);
	int	result = 0;
	unsigned char	num;
	if (inHexStr.GetLength() == 4)	{
		for (int i=0;i<4;i++)	{
			num = inHexStr.GetAt(3-i);
			if (num >= 0x30 && num <= 0x39)	{			// 0-9
				result += (int(int(pow(16,i))) * (num - 0x30));
			}
			else if (num >= 0x41 && num <= 0x46)	{	// A-F
				result += (int(pow(16,i)) * (num - 0x41 + 10));
			}
			else if (num >= 0x61 && num <= 0x66)	{	// a-f
				result += (int(pow(16,i)) * (num - 0x61 + 10));
			}
			else	{
				// Ă͂ȂȂ
				ASSERT(FALSE);
				return -1;
			}
		}
	}
	return result;
}

/*-------------------------------------------------------------------------*/
// Int2Hex4Byte	lSoCg̕ɕϊ
/*-------------------------------------------------------------------------*/
CString
Int2Hex4Byte(long inCodeNum)
{
	char theHexChrs[6];
	CString	theHexStr = _itoa(inCodeNum,theHexChrs,16);
	theHexStr = _T("0000") + theHexStr;
	theHexStr = theHexStr.Right(4);
	theHexStr.MakeUpper();
	return theHexStr;
}

/*-------------------------------------------------------------------------*/
// W2AHelper	 Unicode -> SJis 
/*-------------------------------------------------------------------------*/
LPSTR W2AHelper(LPSTR lpa, LPCWSTR lpw, int nChars)
{
	if (lpw == NULL)	return NULL;
	ASSERT(lpa != NULL);
	lpa[0] = '\0';
	WideCharToMultiByte(CP_ACP, 0, lpw, -1, lpa, nChars, NULL, NULL);
	return lpa;
}

/*-------------------------------------------------------------------------*/
// A2WHelper	 SJis -> Unicode 
/*-------------------------------------------------------------------------*/
LPWSTR	A2WHelper(LPWSTR lpw, LPCSTR lpa, int nChars)
{
	if (lpa == NULL)	return NULL;
	ASSERT(lpw != NULL);
	lpw[0] = 0x0;
	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, lpa, -1, lpw, nChars);
	return lpw;
}

/*-------------------------------------------------------------------------*/
// SwitchEudc		OtHg؂ւ							static
/*-------------------------------------------------------------------------*/
int SwitchEudc(
	CString	inUserFileName,
	CString	inTargetFont,
	CString	inCodePage)
{

	// inUserFileName = "" ̏ꍇ́A^[QbgtHg̃N
	// inTargetFont = "" ̏ꍇ́ASẴtHg^[Qbg(̏ꍇ S=EUDC.TTEɂȂ)
	// inCodePage = "" ̏ꍇ 932 gpi{̂boj

	BOOL	result	= 0;

	// o^tHgt@C󔒂̏ꍇ́A^[QbgtHg̃N)
	BOOL	isDel = (inUserFileName.GetLength() == 0);

	// O̕ύX
	BOOL (WINAPI *fpEnableEUDC)(BOOL);
	HINSTANCE hLib = LoadLibrary("GDI32.DLL");
	if(hLib)	{
		fpEnableEUDC = (BOOL (WINAPI *)(BOOL))GetProcAddress(hLib,"EnableEUDC");
	}
	else	return ERR_DLL_ENTRY;

	// O̕ύX̂߂̑O
	(*fpEnableEUDC)(FALSE);

	// WXg
	HKEY	hKey	= NULL;
	DWORD	theBufSize;
	CString	theSubKey = CString(_T("EUDC\\"));
	theSubKey += inCodePage;
	if (ERROR_SUCCESS != ::RegOpenKeyEx(HKEY_CURRENT_USER,theSubKey,0,
										KEY_ALL_ACCESS,&hKey))		{
		// WXg̃I[vɎsiR[hy[WWXgɂȂƎsj
		return ERR_REG_NOTOPEN;
	}
	if (hKey)	{
		if (isDel)	{
			// WXgL[̍폜
			CString	theDefaultTarget = DEFAULT_SYSEUDCFONT;
			if (inTargetFont == theDefaultTarget)	{
				// VXeftHg̏ꍇ́AEUDC.TTE ݒ
				CString	theDefaultFontFile = DEFAULT_EUDCFILE;
				theBufSize = theDefaultFontFile.GetLength();
				if (ERROR_SUCCESS != ::RegSetValueEx(hKey,inTargetFont,
						NULL,REG_SZ,(UCHAR*)theDefaultFontFile.GetBuffer(theBufSize),theBufSize))	{
					// WXg݂̏Ɏs
					result = ERR_REG_WRITE;
				}
			}
			else	{
				// WXgL[̍폜
				if (ERROR_SUCCESS != ::RegDeleteValue(hKey,inTargetFont))	{
					// WXg̍폜Ɏs
					result = ERR_REG_DELETE;
				}
			}
		}
		else	{
			// l̐ݒ
			theBufSize = inUserFileName.GetLength();
			if (ERROR_SUCCESS != ::RegSetValueEx(hKey,inTargetFont,
					NULL,REG_SZ,(UCHAR*)inUserFileName.GetBuffer(theBufSize),theBufSize))	{
				// WXg݂̏Ɏs
				result = ERR_REG_WRITE;
			}
		}
		// L[nh
		::RegCloseKey(hKey);
	}

	// O̕ύX
	(*fpEnableEUDC)(TRUE);
	
	// CůJ
	if(hLib)	FreeLibrary(hLib);

	return result;
}

