/////////////////////////////////////////////////////////////////////////////
//
// Copyright(C) 2003 Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	2003.02.04
///
// HostCharTblCtrl.cpp
//
// CHostCharTblCtrl NX̓̒`
//
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HostCharTblCtrl.h"
#include "HostCodeList.h"
#include "HostCodeListDoc.h"
#include "FukidasiDlg.h"
#include "EtcTools.h"
#include <afxole.h>
#include <IMM.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// B CHostCodeListApp IuWFNg

extern	CHostCodeListApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CHostCharTblCtrl

/*-------------------------------------------------------------------------*/
// CHostCharTblCtrl			RXgN^
/*-------------------------------------------------------------------------*/
CHostCharTblCtrl::CHostCharTblCtrl()
	: CCharTblCtrl()
{
	m_DocP = NULL;
}

/*-------------------------------------------------------------------------*/
// ~CHostCharTblCtrl			fXgN^
/*-------------------------------------------------------------------------*/
CHostCharTblCtrl::~CHostCharTblCtrl()
{
	m_DocP = NULL;
}

BEGIN_MESSAGE_MAP(CHostCharTblCtrl, CCharTblCtrl)
	//{{AFX_MSG_MAP(CHostCharTblCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/*-------------------------------------------------------------------------*/
// InitialSetting			Xg̏
/*-------------------------------------------------------------------------*/
void
CHostCharTblCtrl::InitialSetting()
{
	// hLg̎o
	CDocument*	pDoc = dynamic_cast<CFrameWnd*>(AfxGetMainWnd())->GetActiveDocument();
	m_DocP = dynamic_cast<CHostCodeListDoc*>(pDoc);
	ASSERT(m_DocP != NULL);
}

/*-------------------------------------------------------------------------*/
// TblInitialSetting		e[uXg̏
/*-------------------------------------------------------------------------*/
void
CHostCharTblCtrl::TblInitialSetting()
{
	if (m_DocP == NULL)	return;

	// _~[̕OXgsǉ
	ResetContent();
	int	theKanjiSuu = m_DocP->GetHostCodeTblSize() / 2;
	int	theLineCount = (theKanjiSuu + (ITEM_X_CHARS -1)) / ITEM_X_CHARS;
	for (int i=0;i<theLineCount;i++)	{
		AddString(_T(""));
	}

	// ŏI(ȂƁAŏ̃}EXNbN܂Ȃ)
	SetCurSel(0);
}

/*-------------------------------------------------------------------------*/
// DrawItemSelf		ACe
/*-------------------------------------------------------------------------*/
void
CHostCharTblCtrl::DrawItemSelf(
	LPDRAWITEMSTRUCT lpDIS)
{
	// Xg̔ԍ
	int theListNo = lpDIS->itemID;
	// e[u̔ԍiԍ́j
	int the1StAddr = LineNo2FirstAddr(theListNo);
	if (the1StAddr == 0)		return;		// ԕ

	// zXgR[he[u
	CHAR*	theTblP = (m_DocP ? m_DocP->GetHostCodeTbl() : NULL);				

	// pcb̎o
	CDC* pDC = CDC::FromHandle(lpDIS->hDC);

	// ݒ
	pDC->SetBkMode(TRANSPARENT);
	CPen	theBluePen(PS_SOLID,2,RGB_BLUE);	// Ip̐F
	CPen*	theOldPen  = NULL;
	CBrush	theLGlayBrush;
	theLGlayBrush.CreateSolidBrush(RGB_LGLAY);	
	CBrush	theLYellowBrush;
	theLYellowBrush.CreateSolidBrush(RGB_LYELLOW);	

	// tHg̐ݒ
	CFont	theKanjiFont;
	theKanjiFont.CreatePointFont(
			theApp.GetDispFontSize(),theApp.GetShowFont(),pDC);
	CFont	theInfoFont;
	theInfoFont.CreatePointFont(90,DEFAULT_FIX_FONT,pDC);
	CFont*	theOldFont = NULL;

	CRect	theItemFrame(lpDIS->rcItem);
	CRect	theRect;
	int		i;

	// s̍ŏ̋`
	theRect = theItemFrame;
	theRect.left += ITEM_LEFT_TITL;
	theRect.right = theRect.left + ITEM_CHAR_X;
	theRect.DeflateRect(1,1);


	// 
	UCHAR		theSJis[3];
	memset(theSJis,0x0,3);
	int	the1StTblNo = Addr2TblNo(the1StAddr);
	long	theAddr = the1StAddr;
	for (i=0;i<ITEM_X_CHARS;i++)	{
		if (IsValidAddr(theAddr))	{
			if (theTblP)	{				
				// gݗ
				CRect	theKjRect = theRect;
				INT	theKCharPos = (the1StTblNo + i) * 2;
				theSJis[0] = (UCHAR)*(theTblP + theKCharPos);
				theSJis[1] = (UCHAR)*(theTblP + theKCharPos + 1);

				// SJISAhX̕\
				pDC->SetTextColor(RGB_BLUE);
				if (theAddr >= HCODE_START_GAIJI && theAddr <= HCODE_END_GAIJI)	{
					pDC->SetTextColor(RGB_RED);	// ÕAhX͐
				}
				if (theOldFont != NULL)	pDC->SelectObject(theOldFont); 
				theOldFont = pDC->SelectObject(&theInfoFont);
				CString	theSJisAddr;
				theSJisAddr.Format(_T("%4X"),0xFFFF & ((theSJis[0] << 8) + theSJis[1]));
				theKjRect.top++;
				pDC->DrawText(theSJisAddr,&theKjRect,DT_TOP + DT_CENTER + DT_SINGLELINE);
				if (theAddr == HCODE_START_ADDR)	{
					// Oŋ 4040 Ă
					theKjRect.top += 24;
					pDC->SetTextColor(RGB_BLACK);
					pDC->DrawText(_T("(4040)"),&theKjRect,DT_TOP + DT_CENTER + DT_SINGLELINE);
					pDC->SetTextColor(RGB_GLAY);
					theKjRect.top += 14;
					pDC->DrawText(_T(""),&theKjRect,DT_TOP + DT_CENTER + DT_SINGLELINE);
				}
				else	{
					// \

					pDC->SetTextColor(RGB_BLACK);
					if (theOldFont != NULL)	pDC->SelectObject(theOldFont); 
					theOldFont = pDC->SelectObject(&theKanjiFont);
					theKjRect = theRect;
					theKjRect.DeflateRect(4,4);
					theKjRect.OffsetRect(0,6);
					pDC->DrawText(theSJis,&theKjRect,DT_CENTER + DT_VCENTER + DT_SINGLELINE);
				}
			}
		}
		else	{
			// OGA
			pDC->FillRect(&theRect,&theLGlayBrush);	
		}
		theAddr++;
		// ̋`ֈړ
		theRect.OffsetRect(ITEM_CHAR_X,0);
	}

 	// GDIIuWFNg̃XgA
	pDC->SetTextColor(RGB_BLACK);
	if (theOldPen  != NULL)	pDC->SelectObject(theOldPen);
	if (theOldFont != NULL)	pDC->SelectObject(theOldFont); 
}


/*-------------------------------------------------------------------------*/
// IsValidAddr	AhXL
/*-------------------------------------------------------------------------*/
BOOL CHostCharTblCtrl::IsValidAddr(long inAddr)
{
	// OAhX̃`FbN
	if (HCODE_START_ADDR > inAddr ||
		HCODE_END_ADDR   < inAddr)	return false;

	// zXgR[he[u̕`FbN
	BOOL	result	= false;
	CHAR*	theTblP	= (m_DocP ? m_DocP->GetHostCodeTbl() : NULL);				
	if (theTblP)	{
		INT	theKCharPos = Addr2TblNo(inAddr) * 2;
		if ((UCHAR)(*(theTblP + theKCharPos))		>= 0xFC && 
			(UCHAR)(*(theTblP + theKCharPos + 1))	>= 0xFB)	{
			// ̗L`FbN(FCFB͖j
		}
		else	result = true;	
	}
	
	return result;
}

/*-------------------------------------------------------------------------*/
// IsValidAddrKChar	AhXƕL				static
/*-------------------------------------------------------------------------*/
BOOL CHostCharTblCtrl::IsValidAddrKChar(long inAddr,CString inKanji)
{
	// OAhX̃`FbN
	if (HCODE_START_ADDR > inAddr ||
		HCODE_END_ADDR   < inAddr)	return false;

	// ̗L`FbN(FCFB͖j
	BOOL	result	= false;
	if (inKanji.GetLength() == 2)	{
		if ((UCHAR)(inKanji.GetAt(0))	>= 0xFC && 
			(UCHAR)(inKanji.GetAt(1))	>= 0xFB)	{
			// ̗L`FbN(FCFB͖j
		}
		else	result = true;	
	}

	return result;
}

/*-------------------------------------------------------------------------*/
// IsValidTblNo	e[uԍAhXƂėL
/*-------------------------------------------------------------------------*/
BOOL CHostCharTblCtrl::IsValidTblNo(int inTblNo)
{
	return (IsValidAddr(TblNo2Addr(inTblNo)));
}

/*-------------------------------------------------------------------------*/
// GetSelectData	I𒆂̊o
/*-------------------------------------------------------------------------*/
CString CHostCharTblCtrl::GetSelectData()
{
	CString	theStr = _T("");
	int theSelect = GetCurSel();
	if (theSelect < 0)	return theStr;	// ԕ

	// Ie[uԍԍ
	int	theTblNo = theSelect * ITEM_X_CHARS + m_Col - 1;

	CHAR*	theTblP	= (m_DocP ? m_DocP->GetHostCodeTbl() : NULL);				
	if (theTblP)	{
		UCHAR		theSJis[3];
		memset(theSJis,0x0,3);
		INT	theKCharPos = theTblNo * 2;
		theSJis[0] = (UCHAR)*(theTblP + theKCharPos);
		theSJis[1] = (UCHAR)*(theTblP + theKCharPos + 1);
		theStr = theSJis;
	}

	return theStr;
}
/*-------------------------------------------------------------------------*/
// ShowKanjiZoom	I̊g\
/*-------------------------------------------------------------------------*/
void CHostCharTblCtrl::ShowKanjiZoom() 
{
	int theSelect = GetCurSel();
	if (theSelect < 0)	return;	// ԕ

	// Ie[uԍ
	int	theTblNo = theSelect * ITEM_X_CHARS + m_Col - 1;
	// I`
	CRect	theSelRc;
	if (!TblNo2Rect(theTblNo,theSelRc))	return;
	// L
	if (!IsValidTblNo(theTblNo))	return;

	// g\̐o
	CPoint	thePoint(theSelRc.left + 10,theSelRc.top + 10);
	CFukidasiDlg	inputDlg(thePoint,this);
	inputDlg.DoModal();
}

/*-------------------------------------------------------------------------*/
// ShowKanjiYomi	I̓ǂݕ\
/*-------------------------------------------------------------------------*/
void CHostCharTblCtrl::ShowKanjiYomi() 
{
	int theSelect = GetCurSel();
	if (theSelect < 0)	return;	// ԕ

	// Ie[uԍ
	int	theTblNo = theSelect * ITEM_X_CHARS + m_Col - 1;

	// L
	if (!IsValidTblNo(theTblNo))	return;

	// I̎o
	CString	theKanji = GetSelectData();
	if (theKanji.IsEmpty())	return;


	// O̓_
	INT	theAddr = CCharTblCtrl::TblNo2Addr(theTblNo);
	if (theAddr >= HCODE_START_GAIJI && theAddr <= HCODE_END_GAIJI)	return;

	// ǂ݂̎擾
	CString	theYomi = _T("");
	HIMC	theImcH	= ::ImmGetContext(m_hWnd);
	HKL		theKlH	= ::GetKeyboardLayout(0);
	DWORD	theSize		   = ::ImmGetConversionList(
								theKlH, theImcH, theKanji, NULL, 0, GCL_REVERSECONVERSION);
	LPCANDIDATELIST	lpCand = (LPCANDIDATELIST)::HeapAlloc(
								::GetProcessHeap(),HEAP_ZERO_MEMORY,theSize);
	::ImmGetConversionList(theKlH,theImcH,theKanji,lpCand,theSize,GCL_REVERSECONVERSION);
	if (theSize > 0)	{
		for (unsigned int i = 0; i< lpCand->dwCount; i++)	{
			CString	theWk;
			theWk.Format(_T("u%sv"),(LPBYTE)lpCand + lpCand->dwOffset[i]);
			theYomi += theWk;
			if (theYomi.GetLength() > 255)	break;	// Ȃɂ͖ł
		}
	}
	::ImmReleaseContext(m_hWnd,theImcH);
	::HeapFree(GetProcessHeap(),0,lpCand);

	// ǂݕ\
	CString	theMsg,theFmt;
	VERIFY(theFmt.LoadString(IDS_KANJI_YOMI));
	if (theAddr == 0x4140)	theAddr = 0x4040;
	theMsg.Format(theFmt,theKanji,theAddr,theYomi);
	AfxMessageBox(theMsg,MB_ICONINFORMATION);
}


/////////////////////////////////////////////////////////////////////////////
// CHostCharTblCtrl bZ[W nh

/*-------------------------------------------------------------------------*/
// OnLButtonDown	{^_E
/*-------------------------------------------------------------------------*/
void CHostCharTblCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// 

	// {
	CCharTblCtrl::OnLButtonDown(nFlags, point);
}

/*-------------------------------------------------------------------------*/
// OnRButtonDown	E{^_E
/*-------------------------------------------------------------------------*/
void CHostCharTblCtrl::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// ReNXgj[̂߂ɁAENbNłIړ
	BOOL	isOutside = TRUE;
	UINT	theListNo = ItemFromPoint(point,isOutside);
	if (theListNo >= 0 && !isOutside)	{
		SetCurSel(theListNo);
		CPoint	thePoint;
		::GetCursorPos(&thePoint);
		OnSelect(thePoint);
	}

	// {
	CCharTblCtrl::OnRButtonDown(nFlags, point);
}

/*-------------------------------------------------------------------------*/
// OnLButtonDblClk	{^_uNbN
/*-------------------------------------------------------------------------*/
void CHostCharTblCtrl::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// I̊g\
	ShowKanjiZoom();
	
	// {
	CCharTblCtrl::OnLButtonDblClk(nFlags, point);
}

/*-------------------------------------------------------------------------*/
// OnContextMenu	ReNXgj[
/*-------------------------------------------------------------------------*/
void CHostCharTblCtrl::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// I
	CCharTblCtrl::OnLButtonDown(0,point);

	// |bvAbv
	CMenu	theMenu;
	if (theMenu.LoadMenu(IDR_POPMENU_LIST))	{
		CMenu*	pPopup = theMenu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		pPopup->TrackPopupMenu(TPM_LEFTALIGN + TPM_RIGHTBUTTON,
						point.x,point.y,CWnd::GetForegroundWindow());
	}	
}



