/////////////////////////////////////////////////////////////////////////////
//
// Copyright(C) 2003 Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	2003.02.04
///
// HostCodeList.cpp
//
// CHostCodeListApp NX̓̒`
//
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HostCodeList.h"

#include "MainFrm.h"
#include "HostCodeListDoc.h"
#include "HostCodeListView.h"
#include "EtcTools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListApp

BEGIN_MESSAGE_MAP(CHostCodeListApp, CWinApp)
	//{{AFX_MSG_MAP(CHostCodeListApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// ẄZbgAbv R}h
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListApp NX̍\z

/*-------------------------------------------------------------------------*/
// CHostCodeListApp			RXgN^
/*-------------------------------------------------------------------------*/
CHostCodeListApp::CHostCodeListApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// B CHostCodeListApp IuWFNg

CHostCodeListApp theApp;

// dNh~p~[ebNX
static	HANDLE hMutexApp = NULL;	

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListApp NX̏

/*-------------------------------------------------------------------------*/
// InitInstance			CX^X̏
/*-------------------------------------------------------------------------*/
BOOL CHostCodeListApp::InitInstance()
{
	AfxEnableControlContainer();

	// QdNh~̂߃~[ebNXIuWFNg
	hMutexApp = ::CreateMutex(NULL,TRUE, _APPL_MUTEX);
	if (GetLastError() == ERROR_ALREADY_EXISTS)	{
		// OAvP[ṼCEBhET
		CWnd* pPrevWnd = CWnd::GetDesktopWindow()->GetWindow(GW_CHILD);
		while (pPrevWnd)	{
			if (::GetProp(pPrevWnd->GetSafeHwnd(),_APPL_MUTEX))	{
				// tH[JX
				if (pPrevWnd->IsIconic())
					pPrevWnd->ShowWindow(SW_RESTORE);
				pPrevWnd->SetForegroundWindow();
				pPrevWnd->GetLastActivePopup()->SetForegroundWindow();
				return FALSE;
			}		
			pPrevWnd = pPrevWnd->GetWindow(GW_HWNDNEXT);
		}
		
		TRACE("Could not find previous instance main window!\n");
		return FALSE;
	}

#ifdef _AFXDLL
	Enable3dControls();		// L DLL ̒ MFC gpꍇɂ͂ĂяoĂB
#else
	Enable3dControlsStatic();	// MFC ƐÓIɃNĂꍇɂ͂ĂяoĂB
#endif

	// WXggpȂŁAINI gp
	CString	theIntFIie = GetAppPath();
	free((void*)m_pszProfileName);
	theIntFIie += _T("HostCodeList.INI");
	m_pszProfileName=_tcsdup(_T(theIntFIie));

	// WXgliINIj̓ǂݏo

	// O\p̃NtHg
	m_ShowFont = GetProfileString(REGKEY_SETTING, REGKEY_SHOW_FONT);
	if (m_ShowFont.IsEmpty())	{
		m_ShowFont = DEFAULT_SHOW_FONT;
		WriteProfileString(REGKEY_SETTING, REGKEY_SHOW_FONT,m_ShowFont);
	}

	// \tHgTCY
	m_DispFontSize = GetProfileInt(REGKEY_SETTING, REGKEY_DISP_FONT_SIZE,0);
	if (m_DispFontSize <= 0)	{
		m_DispFontSize = DEFAULT_DISP_FONT_SIZE;
		WriteProfileInt(REGKEY_SETTING, REGKEY_DISP_FONT_SIZE,m_DispFontSize);
	}

	// otHgTCY
	m_FukidashiFontSize = GetProfileInt(REGKEY_SETTING, REGKEY_FUKIDASHI_FONT_SIZE,0);
	if (m_FukidashiFontSize <= 0)	{
		m_FukidashiFontSize = DEFAULT_FUKIDASHI_FONT_SIZE;
		WriteProfileInt(REGKEY_SETTING, REGKEY_FUKIDASHI_FONT_SIZE,m_FukidashiFontSize);
	}

	// o̕ij
	m_FukidashiStringWidth = GetProfileInt(REGKEY_SETTING, REGKEY_FUKIDASHI_STR_WIDTH,0);
	if (m_FukidashiStringWidth <= 0)	{
		m_FukidashiStringWidth = DEFAULT_FUKIDASHI_STR_WIDTH;
		WriteProfileInt(REGKEY_SETTING, REGKEY_FUKIDASHI_STR_WIDTH,m_FukidashiStringWidth);
	}

	// e[ut@C`FbNp̒
	m_TblLength = GetProfileInt(REGKEY_SETTING, REGKEY_TBL_LENGTH,0);
	if (m_TblLength <= 0)	{
		m_TblLength = DEFAULT_TBL_LENGTH;
		WriteProfileInt(REGKEY_SETTING, REGKEY_TBL_LENGTH,m_TblLength);
	}

	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CHostCodeListDoc),
		RUNTIME_CLASS(CMainFrame),       // C SDI t[ EBhE
		RUNTIME_CLASS(CHostCodeListView));
	AddDocTemplate(pDocTemplate);

	// DDEAfile open ȂǕW̃VF R}h̃R}hC͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// R}hCŃfBXpb` R}hw肵܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// C EBhEꂽ̂ŁA\ƍXVs܂B
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	// dN`FbN̂߂̃^O𖄂߂
	::SetProp(m_pMainWnd->GetSafeHwnd(),_APPL_MUTEX,(HANDLE)1);

	return TRUE;
}

/*-------------------------------------------------------------------------*/
// ExitInstance			Ȉ
/*-------------------------------------------------------------------------*/
int CHostCodeListApp::ExitInstance() 
{
	// QdN`FbNp̃~[ebNXj
	::ReleaseMutex(hMutexApp);
	hMutexApp = NULL;

	// {
	return CWinApp::ExitInstance();
}

/*-------------------------------------------------------------------------*/
// GetAppPath		AvP[ṼtpXo
/*-------------------------------------------------------------------------*/
CString CHostCodeListApp::GetAppPath()
{
	// AvP[VpX擾
	// iftHg̃wvt@CpX擾j
	CHAR	appPath[MAX_PATH+1] = "";
	strcpy(appPath,m_pszHelpFilePath);
	for (INT i=strlen(appPath)-1;i>=0;i--)	{
		// ŏ \ ܂ŃJbg
		if (appPath[i] == '\\')	{
			appPath[i+1] = 0x0;
			break;
		}
	}
	return	CString(appPath);
}

/*-------------------------------------------------------------------------*/
// GetFontPath		tHg̃tpXo
/*-------------------------------------------------------------------------*/
CString CHostCodeListApp::GetFontPath()
{
	TCHAR 	theSysPath[MAX_PATH];
	::GetWindowsDirectory(theSysPath,sizeof(theSysPath));
	return (CString(theSysPath) + CString(SYSTEM_FONTS));
}



/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
		// bZ[W nh͂܂B
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh͂܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CHostCodeListApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

