/////////////////////////////////////////////////////////////////////////////
//
// Copyright(C) 2003 Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	2003.02.04
///
// HostCodeListDoc.cpp
//
// CHostCodeListDoc NX̓̒`
//
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HostCodeList.h"
#include "CharTblCtrl.h"
#include "FindDlg.h"
#include "HostCodeListView.h"

#include "HostCodeListDoc.h"
#include "EtcTools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// B CHostCodeListApp IuWFNg

extern	CHostCodeListApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListDoc

IMPLEMENT_DYNCREATE(CHostCodeListDoc, CDocument)

BEGIN_MESSAGE_MAP(CHostCodeListDoc, CDocument)
	//{{AFX_MSG_MAP(CHostCodeListDoc)
	ON_COMMAND(ID_CODE_TBL_LOAD, OnHostCodeLoad)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW, OnUpdateFilePrintPreview)
	ON_COMMAND(ID_KANJI_FIND, OnKanjiFind)
	ON_UPDATE_COMMAND_UI(ID_KANJI_FIND, OnUpdateKanjiFind)
	ON_UPDATE_COMMAND_UI(ID_POP_YOMI, OnUpdatePopYomi)
	ON_UPDATE_COMMAND_UI(ID_POP_ZOOM, OnUpdatePopZoom)
	ON_COMMAND(ID_POP_ZOOM, OnPopZoom)
	ON_COMMAND(ID_POP_YOMI, OnPopYomi)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListDoc NX̍\z/

/*-------------------------------------------------------------------------*/
// CHostCodeListDoc			RXgN^EfXgN^
/*-------------------------------------------------------------------------*/
CHostCodeListDoc::CHostCodeListDoc()
{
	// oϐ̏
	m_HostCodeTblFile	= _T("");
	m_HostCodeTblP		= NULL;
	m_HostCodeTblSize	= 0;
}

CHostCodeListDoc::~CHostCodeListDoc()
{
	// zXgR[he[u̔j
	if (m_HostCodeTblP)	delete [] m_HostCodeTblP;
	m_HostCodeTblP = NULL;
}

/*-------------------------------------------------------------------------*/
// OnNewDocument		VK̏igpj
/*-------------------------------------------------------------------------*/
BOOL CHostCodeListDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListDoc VAC[[V

/*-------------------------------------------------------------------------*/
// Serialize		igpj
/*-------------------------------------------------------------------------*/
void CHostCodeListDoc::Serialize(CArchive& ar)
{
}

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListDoc NX̐ff

#ifdef _DEBUG
void CHostCodeListDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CHostCodeListDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListDoc R}h

/*-------------------------------------------------------------------------*/
// OnHostCodeLoad		zXgR[he[ut@C̑I
/*-------------------------------------------------------------------------*/
void CHostCodeListDoc::OnHostCodeLoad() 
{
	// t@C̎o
	CString	theStrAns	= m_HostCodeTblFile;
	CString	theFileName	= theStrAns;
	INT	theLen = theFileName.GetLength();
	INT	theLastPos = -1;
	for (INT i=theLen;i>=1;i--)	{
		if (theFileName[i-1] == '\\')	{
			theLastPos = i;
			break;
		}
	}
	theFileName = theFileName.Right(theLen - theLastPos);

	// _CAO̓^Cg
	CString	theDlgTitl;
	VERIFY(theDlgTitl.LoadString(IDS_CODE_TBL_SELECT));

	// t@CItB^
	CString	theFilterStr;
	VERIFY(theFilterStr.LoadString(IDS_CODE_TBL_FILE_FILTER));

	// ̓t@Cw
	CHAR*	theBuffP = new CHAR[_MAX_PATH+1];
	ASSERT(theBuffP != NULL);
	strcpy(theBuffP,(char*)LPCTSTR (theFileName));
	CFileDialog	theFileDlg(TRUE,NULL,"",
		OFN_ENABLEHOOK | 
		OFN_EXPLORER | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		theFilterStr);
	theFileDlg.m_ofn.lpstrInitialDir = theStrAns;
	theFileDlg.m_ofn.lpstrTitle  = theDlgTitl;
	theFileDlg.m_ofn.nMaxFile    = _MAX_PATH;
	theFileDlg.m_ofn.lpstrFile   = theBuffP;

	// t@C_CAO
	BOOL	result = (IDOK == theFileDlg.DoModal());
	
	if (result)	{
		m_HostCodeTblFile = theFileDlg.GetPathName ();
		CFile	theFile;
		if (theFile.Open(m_HostCodeTblFile,CFile::modeRead))	{
			// \pt@C쐬
			CWaitCursor	wait;
			DoMakeShowTbl(&theFile);
			theFile.Close();
		}
		else	{
			CString	theMsg,theFmt;
			VERIFY(theFmt.LoadString(IDS_ERR_HCODE_TBL_NOTOPEN));
			theMsg.Format(theFmt,m_HostCodeTblFile);
			AfxMessageBox(theMsg);
		}
		// r[XV
		UpdateAllViews(NULL);
		// ^CgXV
		AfxGetMainWnd()->SetWindowText(m_HostCodeTblFile);
	}
	if (theBuffP != NULL)	delete [] theBuffP;
}

/*-------------------------------------------------------------------------*/
// DoMakeShowTbl		\pe[u쐬
/*-------------------------------------------------------------------------*/
void CHostCodeListDoc::DoMakeShowTbl(CFile*	inFile) 
{
	// inFile = PCOMM̃zXgR[hϊe[u
	ASSERT(inFile != NULL);

	// zXgR[he[uUj
	if (m_HostCodeTblP)	delete [] m_HostCodeTblP;
	m_HostCodeTblP = NULL;

	// PCOMM̃zXgR[hAIWie[u̓ǂݍ
	UINT	theBuffSize = theApp.GetTblLength();
	CHAR*	theBuffP = new CHAR[theBuffSize+1];
	ASSERT(theBuffP != NULL);
	if (theBuffP == NULL)	{
		// obt@ĂłȂ
		AfxMessageBox(IDS_ERR_NOTBUFFALLOC);
		return;
	}
	else	{
		if (theBuffSize != inFile->Read(theBuffP,theBuffSize+1))	{
			// e[uw̃oCgł͂Ȃ
			CString	theMsg,theFmt;
			VERIFY(theFmt.LoadString(IDS_ERR_HCODE_TBL_NOTREAD));
			theMsg.Format(theFmt,m_HostCodeTblFile,theBuffSize);
			AfxMessageBox(theMsg);
			delete [] theBuffP;
			return;
		}
		else	{
			if (theBuffSize < 382)	{
				// p[^ُi:蓾ȂƂǁj
				AfxMessageBox(IDS_ERR_HCODE_TBL_NOTREAD2);
				delete [] theBuffP;
				return;
			}
			else	{
				// OK !
			}
		}
	}

	// \t@C̍쐬
	CString	theWkFileName = theApp.GetAppPath() + _T("temp.tbl");
	CFile	theFile;
	if (!theFile.Open(theWkFileName,CFile::modeReadWrite + CFile::modeCreate))	{
		// e|t@C쐬łȂ
		CString	theMsg,theFmt;
		VERIFY(theFmt.LoadString(IDS_ERR_NOTTEMP_TBL));
		theMsg.Format(theFmt,theWkFileName);
		AfxMessageBox(theMsg);
		delete [] theBuffP;
		return;
	}
	else	{

		/*
		IWit@ĆA0x4140 ̕сiA 4140  4040 ̃Xy[Xj
		ŁA382A380oCg132oCg̖gpe[u
		ȂĂ

	  @\t@ĆAgpɃ_~[}A0x4140 x^̕тɂȂ
		悤ɕ\t@C쐬itemp.tblj
		Le[uoCg 25728 oCg
		*/

		CHAR*	theMarkP = theBuffP;
		UCHAR	theDummy[CONS_PCM_TBLDUMMY];
		for (INT i=0;i<CONS_PCM_TBLDUMMY;i += 2)	{
			theDummy[i]		= 0xFC;		// 0xFCFB ̓_~[R[h  
			theDummy[i+1]	= 0xFB;
		}
		// ܂ CONS_PCM_TBLSTARTPOS oCgo
		theFile.Write(theMarkP,CONS_PCM_TBLSTARTPOS);
		theMarkP += CONS_PCM_TBLSTARTPOS;
		theFile.Write(theDummy,CONS_PCM_TBLDUMMY);
		INT		theMore = theApp.GetTblLength() - CONS_PCM_TBLSTARTPOS;
		INT		theWriteMore = CONS_PCM_TBLMAX - CONS_PCM_TBLSTARTPOS - CONS_PCM_TBLDUMMY;
		while (theMore > 0 && theWriteMore > 0)	{
			// CONS_PCM_TBLCYCLE oCg CONS_PCM_TBLDUMMY oCg̃_~[o
			theFile.Write(theMarkP,__min(theWriteMore,CONS_PCM_TBLCYCLE));
			theMarkP	 += CONS_PCM_TBLCYCLE;
			theMore		 -= CONS_PCM_TBLCYCLE;
			theWriteMore -= CONS_PCM_TBLCYCLE;
			if (theWriteMore > CONS_PCM_TBLCYCLE)	{
				theFile.Write(theDummy,CONS_PCM_TBLDUMMY);
				theWriteMore -= CONS_PCM_TBLDUMMY;
			}
		}

		// IWĩobt@GAj
		delete [] theBuffP;

		/*
		\t@CA\pe[uizXgR[he[uj쐬
		\t@C 512 ubN 384 ̗Lf[^ 128 ̖f[^
		JԂĂ
		zXgR[he[úA̖ubNč쐬
		*/

		// Lle[uTCY߂
		INT	theLastPos = CCharTblCtrl::Addr2TblNo(HCODE_END_ADDR);
		m_HostCodeTblSize = (theLastPos + 1) * 2;

		// zXgR[he[u̍쐬
		theWriteMore = m_HostCodeTblSize;
		m_HostCodeTblP = new CHAR[m_HostCodeTblSize];
		memset(m_HostCodeTblP,0x0,m_HostCodeTblSize);
		CHAR*	theHCMarkP = m_HostCodeTblP;
		theFile.SeekToBegin();
		while (theWriteMore > 0)	{
			INT	theReadSize = __min(theWriteMore,CONS_TBL_VALID);
			theFile.Read(theHCMarkP,theReadSize);
			theWriteMore -= theReadSize;
			if (theWriteMore > 0)	{
				theHCMarkP += theReadSize;
				theFile.Seek (CONS_TBL_DUMMY,CFile::current);	// _~[XLbv
			}
		}

		theFile.Close();
	}

}

/*-------------------------------------------------------------------------*/
// OnKanjiFind		
/*-------------------------------------------------------------------------*/
void CHostCodeListDoc::OnKanjiFind() 
{
	CFindDlg	theDlg;
	if (theDlg.DoModal() == IDOK)	{
		// 
		CString	theFindStr = theDlg.m_FindStr;
		INT	theTblNo = DoFindKanji(theFindStr);

		if (theTblNo >= 0)	{
			// 
			CHostCodeListView*	theViewP = dynamic_cast<CHostCodeListView*>(GetTargetView());
			ASSERT(theViewP != NULL);
			if (theViewP)	{
				ASSERT(theViewP->m_List.m_hWnd != NULL);
				if (theViewP->m_List.m_hWnd)	{
					theViewP->m_List.SelectTblNo(theTblNo);
				}
			}
		}
		else	{
			// Ȃ
			CString	theMsg,theFmt;
			VERIFY(theFmt.LoadString(IDS_KANJI_NOT_FOUND));
			theMsg.Format(theFmt,theFindStr);
			AfxMessageBox(theMsg);
		}
	}
}

/*-------------------------------------------------------------------------*/
// DoFindKanji		zXgR[he[u犿
/*-------------------------------------------------------------------------*/
INT CHostCodeListDoc::DoFindKanji(CString inFindStr)
{
	// inFindStr  CFindDlg ɂđÓ̓`FbN
	// QoCg͊ASoCg͂PUiƂĈ
	// iQoCg͎̓̕`FbNĂȂǂˁj

	UINT		theCode = 0;
	if (inFindStr.GetLength() == 4)	{
		theCode = Hex4Byte2Int(inFindStr);
	}
	else if (inFindStr.GetLength() == 2)	{
		theCode = ((UCHAR)inFindStr[0] << 8) + (UCHAR)inFindStr[1];
	}

	UCHAR	theFindCode[3];
	theFindCode[0] = (0xFF & (theCode >> 8));
	theFindCode[1] =  0xFF & (theCode);
	theFindCode[2] = 0x0;

	// ͈͂`FbN
	if (theCode >= 0xFCFB || theCode <= 0)	return -1;

	// XL
	CHAR*	theFindP	= m_HostCodeTblP;
	INT		theScnaCnt	= m_HostCodeTblSize / 2;
	LONG	theAddr		= 0;
	INT		theTblNo	= 0;
	for (;theTblNo<theScnaCnt;theTblNo++)	{
		if (theFindCode[0] == (UCHAR)*theFindP && 
			theFindCode[1] == (UCHAR)*(theFindP+1))	{
			// rSI
			theAddr = CCharTblCtrl::TblNo2Addr(theTblNo);
			break;
		}
		theFindP += 2;
	}

	if (theAddr != 0)	{

		// bZ[W
		CString	theMsg,theFmt;
		VERIFY(theFmt.LoadString(IDS_KANJI_FOUND));
		if (theAddr == 0x4140)	theAddr = 0x4040;
		theMsg.Format(theFmt,theFindCode,theCode,theAddr);
		AfxMessageBox(theMsg,MB_ICONINFORMATION);

	}

	return ((theAddr == 0) ? -1 : theTblNo);
}

/*-------------------------------------------------------------------------*/
// OnPopZoom		I𒆂̊g\iReNXgj[j
/*-------------------------------------------------------------------------*/
void CHostCodeListDoc::OnPopZoom() 
{
	CHostCodeListView*	theViewP = dynamic_cast<CHostCodeListView*>(GetTargetView());
	ASSERT(theViewP != NULL);
	if (theViewP)	{
		ASSERT(theViewP->m_List.m_hWnd != NULL);
		if (theViewP->m_List.m_hWnd)	{
			theViewP->m_List.ShowKanjiZoom();
		}
	}
}

/*-------------------------------------------------------------------------*/
// OnPopYomi		I𒆂̊̓ǂݕ\iReNXgj[j
/*-------------------------------------------------------------------------*/
void CHostCodeListDoc::OnPopYomi() 
{
	CHostCodeListView*	theViewP = dynamic_cast<CHostCodeListView*>(GetTargetView());
	ASSERT(theViewP != NULL);
	if (theViewP)	{
		ASSERT(theViewP->m_List.m_hWnd != NULL);
		if (theViewP->m_List.m_hWnd)	{
			theViewP->m_List.ShowKanjiYomi();
		}
	}
}


/*-------------------------------------------------------------------------*/
// vgj[̑@삪ł̂́AtHgt@Cwς̎
/*-------------------------------------------------------------------------*/
void CHostCodeListDoc::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_HostCodeTblP != NULL);
}
void CHostCodeListDoc::OnUpdateFilePrintPreview(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_HostCodeTblP != NULL);
}

/*-------------------------------------------------------------------------*/
// j[̑
/*-------------------------------------------------------------------------*/
void CHostCodeListDoc::OnUpdateKanjiFind(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_HostCodeTblP != NULL);
}

/*-------------------------------------------------------------------------*/
// ReNXgj[̑
/*-------------------------------------------------------------------------*/
void CHostCodeListDoc::OnUpdatePopYomi(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_HostCodeTblP != NULL);
}
void CHostCodeListDoc::OnUpdatePopZoom(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_HostCodeTblP != NULL);
}

