/////////////////////////////////////////////////////////////////////////////
//
// Copyright(C) 2003 Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	2003.02.04
///
// HostCodeListView.cpp
//
// CHostCodeListView NX̓̒`
//
//////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HostCodeList.h"

#include "HostCodeListDoc.h"
#include "HostCodeListView.h"
#include "CharTblCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// B CHostCodeListApp IuWFNg

extern	CHostCodeListApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListView

IMPLEMENT_DYNCREATE(CHostCodeListView, CFormView)

BEGIN_MESSAGE_MAP(CHostCodeListView, CFormView)
	//{{AFX_MSG_MAP(CHostCodeListView)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//    ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/*-------------------------------------------------------------------------*/
// CHostCodeListView			RXgN^EfXgN^
/*-------------------------------------------------------------------------*/
CHostCodeListView::CHostCodeListView()
	: CFormView(CHostCodeListView::IDD)
{
	// oϐ̏
	m_PaperWidth  = 0;
	m_PaperHeight = 0;

	//{{AFX_DATA_INIT(CHostCodeListView)
	//}}AFX_DATA_INIT
}
CHostCodeListView::~CHostCodeListView()
{
}

/*-------------------------------------------------------------------------*/
// DoDataExchange			f[^GNX`FW
/*-------------------------------------------------------------------------*/
void CHostCodeListView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHostCodeListView)
	DDX_Control(pDX, IDC_LIST1, m_List);
	//}}AFX_DATA_MAP
}

/*-------------------------------------------------------------------------*/
// PreCreateWindow			EBhE쐬Ȍ
/*-------------------------------------------------------------------------*/
BOOL CHostCodeListView::PreCreateWindow(CREATESTRUCT& cs)
{
	// {
	return CFormView::PreCreateWindow(cs);
}

/*-------------------------------------------------------------------------*/
// OnInitialUpdate			EBhE쐬̏
/*-------------------------------------------------------------------------*/
void CHostCodeListView::OnInitialUpdate()
{
	// W
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	// Xg̏
	m_List.InitialSetting();

	SetForegroundWindow();

	// t@CI˗
	PostMessage(UWM_TBL_LOAD);
}

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListView NẌ

/*-------------------------------------------------------------------------*/
// OnPreparePrinting	vr[̐ݒ
/*-------------------------------------------------------------------------*/
BOOL CHostCodeListView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// svZ
	ASSERT(GetDocument() != NULL);
	int	theLineCount = ((GetDocument()->GetHostCodeTblSize() / 2) + (YOKO -1)) / YOKO;

	// y[WvZ
	int	thePages	 = (theLineCount + (TATE -1)) / TATE; 
	pInfo->SetMaxPage(thePages);

	// ftHg̈
	return DoPreparePrinting(pInfo);
}

/*-------------------------------------------------------------------------*/
// OnBeginPrinting		Jn̏
/*-------------------------------------------------------------------------*/
void CHostCodeListView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// y[p[TCY
	m_PaperWidth  = pDC->GetDeviceCaps(HORZRES);
	m_PaperHeight = pDC->GetDeviceCaps(VERTRES);
}

/*-------------------------------------------------------------------------*/
// OnEndPrinting		Ȉ
/*-------------------------------------------------------------------------*/
void CHostCodeListView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/*-------------------------------------------------------------------------*/
// OnPrint				
/*-------------------------------------------------------------------------*/
void CHostCodeListView::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{

	// y[p[TCY
	CRect	thePaperRect(0,0,A4_W,A4_H);

	// _}bsO
	pDC->SetMapMode(MM_ISOTROPIC);	// cPFPɃ}bsO
	pDC->SetWindowExt(thePaperRect.right,thePaperRect.bottom);		
	pDC->SetViewportExt(m_PaperWidth,m_PaperHeight);



	// ̈
	//
	//		F16 { 22 ~  8 { (X) ~ 2 = 210
	//		cF23 { 22 ~ 12 { (T) ~ 2 = 296
	thePaperRect.DeflateRect(9,6);

	// giP}XAhX{W}X~cPQ}Xj
	int	i;
	int	x = thePaperRect.left;
	int	y = thePaperRect.top + TOP_SP;
	for (i=0;i<=TATE;i++)	{	// 
		pDC->MoveTo(x,y);
		pDC->LineTo(x + LEFT_SP+LOT * YOKO,y);
		y += LOT;
	}
	x = thePaperRect.left;
	y = thePaperRect.top + TOP_SP;
	for (i=0;i<=YOKO + 1;i++)	{	// c
		pDC->MoveTo(x,y);
		pDC->LineTo(x,y + LOT * TATE);
		if (i==0)	{	
			x += LEFT_SP;
		}
		else	{
			x += LOT;
		}
	}

	// 惏[N
	CFont*	theOldFont = NULL;
	CRect	theRect;
	CString	theStr;

	// tHgt@Cƃy[Wo
	{
		// tHgw
		if (theOldFont != NULL)	pDC->SelectObject(theOldFont); 
		CFont	theAppFont;
		theAppFont.CreatePointFont(FONT_SIZE_M,DEFAULT_FIX_FONT,pDC);
		CHostCodeListDoc*	theDocP = dynamic_cast<CHostCodeListDoc*>(GetDocument());
		// o͕ҏW
		CString	theFmt = _T("νĺð̧ٖF%s@@@̫ĖF%s@@i%d/%dŁj");
		theStr.Format(theFmt,theDocP->GetHostCodeTblFile(),
						theApp.GetShowFont(),
						pInfo->m_nCurPage,pInfo->GetMaxPage());
		theOldFont = pDC->SelectObject(&theAppFont);
		// o͋`
		theRect = thePaperRect;
		theRect.bottom = theRect.top + TOP_SP;
		// 
		pDC->SetTextColor(RGB_BLACK);
		pDC->DrawText(theStr,&theRect,DT_LEFT + DT_VCENTER + DT_SINGLELINE);
	}

	// 擪̃e[uԍiO`jvZ
	int	theTblNo = (pInfo->m_nCurPage - 1) * (TATE * YOKO);

	// P[V\
	{
		// tHgw
		if (theOldFont != NULL)	pDC->SelectObject(theOldFont); 
		CFont	theAppFont;
		theAppFont.CreatePointFont(FONT_SIZE_M,theApp.GetShowFont(),pDC);
		theOldFont = pDC->SelectObject(&theAppFont);
		// o͋`
		theRect = thePaperRect;
		theRect.top		+= TOP_SP;
		theRect.bottom	 = theRect.top  + LOT;
		theRect.right	 = theRect.left + LEFT_SP;
		// ł̐擪P[VvZ
		int the1StTblNo = theTblNo;
		// 
		pDC->SetTextColor(RGB_BLACK);
		for (int y=0;y<TATE;y++)	{
			long	theAddr = CCharTblCtrl::TblNo2Addr(the1StTblNo);
			if (theAddr >= HCODE_START_ADDR && theAddr <= HCODE_END_ADDR)	{
				pDC->DrawText(Int2Hex4Byte(theAddr),&theRect,DT_CENTER + DT_VCENTER + DT_SINGLELINE);
				theRect.OffsetRect(0,LOT);		// ̋`
				the1StTblNo += YOKO;			// ̍s
			}
			else break;
		}
	}

	// zXgR[he[u
	CHostCodeListDoc* theDocP = GetDocument();
	CHAR*	theTblP = (theDocP ? theDocP->GetHostCodeTbl() : NULL);				

	// \
	if (theTblP)	{
		// o͋`
		theRect = thePaperRect;
		theRect.top		+= TOP_SP;
		theRect.bottom	 = theRect.top  + LOT;
		theRect.left	+= LEFT_SP;
		theRect.right	 = theRect.left + LOT;
		
		// SJISAhX̕\tHgw
		CFont	theInfoFont;
		theInfoFont.CreatePointFont(90,DEFAULT_FIX_FONT,pDC);

		// tHgwi_TCYɃ}bsOj
		CFont	theAppFont;
		theAppFont.CreatePointFont(100,theApp.GetShowFont(),pDC);
		LOGFONT	theLogFont;
		theAppFont.GetLogFont(&theLogFont);
		theLogFont.lfHeight = -(LOT - 5);
		CFont	theKanjiFont;
		theKanjiFont.CreateFontIndirect(&theLogFont);

		// ł̐擪P[VvZ
		int	theCurTblNo	= theTblNo;
		int	theOffset	= theTblNo * 2;

		// 
		UCHAR		theSJis[3];
		memset(theSJis,0x0,3);
		pDC->SetTextColor(RGB_BLACK);
		for (int y=0;y<TATE;y++)	{
			for (int x=0;x<YOKO;x++)	{

				// gݗ
				theSJis[0] = (UCHAR)*(theTblP + theOffset);
				theSJis[1] = (UCHAR)*(theTblP + theOffset + 1);
					
				long	theAddr = CCharTblCtrl::TblNo2Addr(theCurTblNo);
				if (CHostCharTblCtrl::IsValidAddrKChar(theAddr,theSJis))	{
	
					// SJISAhX
					CRect	theKjRect = theRect;
					theKjRect.OffsetRect(0,1);
					if (theOldFont != NULL)	pDC->SelectObject(theOldFont); 
					theOldFont = pDC->SelectObject(&theInfoFont);
					CString	theSJisAddr;
					theSJisAddr.Format(_T("%4X"),0xFFFF & ((theSJis[0] << 8) + theSJis[1]));
					pDC->DrawText(theSJisAddr,&theKjRect,
							DT_CENTER + DT_TOP + DT_SINGLELINE);

					if (theAddr == HCODE_START_ADDR)	{
						// Oŋ 4040 Ă
						theKjRect.top += 8;
						pDC->DrawText(_T("(4040)"),&theKjRect,
								DT_CENTER + DT_TOP + DT_SINGLELINE);
						theKjRect.top += 4;
						pDC->DrawText(_T(""),&theKjRect,
								DT_CENTER + DT_TOP + DT_SINGLELINE);
					}
					else	{
						// 
						theKjRect = theRect;
						theKjRect.OffsetRect(0,2);
						if (theOldFont != NULL)	pDC->SelectObject(theOldFont); 
						theOldFont = pDC->SelectObject(&theKanjiFont);
						pDC->DrawText(theSJis,&theKjRect,
								DT_CENTER + DT_VCENTER + DT_SINGLELINE);
					}
				
				}
				theRect.OffsetRect(LOT,0);			// ̉E`
				theCurTblNo++;						// ̃e[uԍ
				theOffset += 2;
			}
			theRect.OffsetRect(-(LOT * YOKO),LOT);	// ̍s̐擪ֈړ
		}
	}

	// GDIIuWFNg̃XgA
	if (theOldFont != NULL)	pDC->SelectObject(theOldFont); 

}

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListView NX̐ff

#ifdef _DEBUG
void CHostCodeListView::AssertValid() const
{
	CFormView::AssertValid();
}

void CHostCodeListView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CHostCodeListDoc* CHostCodeListView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CHostCodeListDoc)));
	return (CHostCodeListDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHostCodeListView NX̃bZ[W nh

/*-------------------------------------------------------------------------*/
// OnUpdate				r[̃Abvf[git@CI㏈j
/*-------------------------------------------------------------------------*/
void CHostCodeListView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// e[uXg̏
	if (m_List.m_hWnd != NULL)	{
		m_List.TblInitialSetting();
	}
}

BOOL CHostCodeListView::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == UWM_TBL_LOAD)	{
		// ŏ̋NŃt@CIJ
		GetDocument()->DoCodeLoad();
		return TRUE;
	}

	return CFormView::PreTranslateMessage(pMsg);
}
